-- Only Seekers Can Attack Hiders
local function allow_pvp_attack(a, v)
    
    if
        gGlobalSyncTable.gameState ~= 3 or
        not gPlayerSyncTable[a.playerIndex].seeker or
        gPlayerSyncTable[v.playerIndex].seeker
    then
        return false
    end

    return true

end

-- PVP Handler
local function on_pvp_attack(a, v)

    if v.playerIndex ~= 0 then return end

    gPlayerSyncTable[v.playerIndex].seeker = true
    network_send(true, {packet = "ON_TAG", message = string_without_hex(gNetworkPlayers[a.playerIndex].name) .. " tagged " .. string_without_hex(gNetworkPlayers[v.playerIndex].name) .. "!"})
    packet_receive({packet = "ON_TAG", message = string_without_hex(gNetworkPlayers[a.playerIndex].name) .. " tagged " .. string_without_hex(gNetworkPlayers[v.playerIndex].name) .. "!"})

end



-- Touch-to-Tag Animations
local touchActs = {
    ACT_VERTICAL_WIND,
    ACT_PULLING_DOOR,
    ACT_PUSHING_DOOR,
    ACT_HEAD_STUCK_IN_GROUND,
    ACT_BUTT_STUCK_IN_GROUND,
    ACT_FEET_STUCK_IN_GROUND,
    ACT_HARD_BACKWARD_GROUND_KB,
    ACT_HARD_FORWARD_GROUND_KB,
    ACT_BACKWARD_GROUND_KB,
    ACT_FORWARD_GROUND_KB,
    ACT_SOFT_BACKWARD_GROUND_KB,
    ACT_SOFT_FORWARD_GROUND_KB,
    ACT_BACKWARD_AIR_KB,
    ACT_FORWARD_AIR_KB,
    ACT_HARD_BACKWARD_AIR_KB,
    ACT_HARD_BACKWARD_AIR_KB,
    ACT_GROUND_BONK,
    ACT_DEATH_EXIT,
    ACT_LAVA_BOOST,
    ACT_DROWNING,
    ACT_BACKWARD_WATER_KB,
    ACT_FORWARD_WATER_KB,
    ACT_PUTTING_ON_CAP,
    ACT_SQUISHED
}

-- Touch-to-Tag Handler
local function on_interact(m, obj, intee)
    if
        gGlobalSyncTable.gameState == 3 and 
        intee == INTERACT_PLAYER and
        m ~= gMarioStates[0]
    then
        for i=0,(MAX_PLAYERS-1) do
            if
                gNetworkPlayers[i].connected and
                gNetworkPlayers[i].currAreaSyncValid and
                obj == gMarioStates[i].marioObj and
                
                gPlayerSyncTable[m.playerIndex].seeker and
                not gPlayerSyncTable[i].seeker and
                
                (
                gMarioStates[i].invincTimer > 0 or
                gMarioStates[i].action & ACT_FLAG_ON_POLE ~= 0 or
                check_acts(gMarioStates[i].action)
                )
            then
                gPlayerSyncTable[i].seeker = true
                network_send(true, {packet = "ON_TAG", message = string_without_hex(gNetworkPlayers[m.playerIndex].name) .. " tagged " .. string_without_hex(gNetworkPlayers[i].name) .. "!"})
                packet_receive({packet = "ON_TAG", message = string_without_hex(gNetworkPlayers[m.playerIndex].name) .. " tagged " .. string_without_hex(gNetworkPlayers[i].name) .. "!"})
            end
        end
    end
end

function check_acts(vAct)
    for i = 1, #touchActs do
        if vAct == touchActs[i] then
            return true
        end
    end
    return false
end

hook_event(HOOK_ALLOW_PVP_ATTACK, allow_pvp_attack)
hook_event(HOOK_ON_PVP_ATTACK, on_pvp_attack)
hook_event(HOOK_ON_INTERACT, on_interact)